↓ Skip to main content
  1. Posts/

【dp专题002】hdu 4489 The King’s Ups and Downs (dp)

·750 words·2 mins
Note: This article is available in Chinese only. 本文暂无英文版本。 View original

题目链接

题意:问长度为n的“波浪”型排列(即1..n每个数出现一次)有多少。波浪型的含义是,“高低高”或者“低高低”

思路:我们考虑当前已经知道i-1个数的波浪型的排列的方案数,那么当第i个数到来时,第i个数一定是最大的。

那么将i插入到某个位置,必须满足该位置前面必须以“高低”结尾,该位置后面必须以“低高”结尾才合法。(特别地,允许前面或者后面为空,这点体现在初始化上)

因此我们分别考虑,用dp[i][0]表示有i位且最后结尾为“高低”的方案数,dp[i][1]表示有i位且最后结尾为“低高”的方案数。

此时我们的情况是,已经有i-1个数,我要把第i个数插在某个位置。

这个位置是不确定的,因为我们需要枚举插入的位置(表现为,枚举插入的第i个数前面有j个数,后面剩余i-1-j个数)

那么第i个数前面是选择哪j个数呢? 组合数为C[i-1][j] (i-1个数选择j个放在前面)

因此长度为i的答案为**sum[i] = sigma{dp[j][0]dp[i-j-1][1]C[i-1][j]} (0=<j<i)

dp[i][0]和dp[i][1]对称,显然相等,都等于sum[i]/2.

我们只需要再预处理一个组合数就好了。

代码实现
 1#include <cstdio>
 2#include <cstring>
 3#include <iostream>
 4#include <algorithm>
 5#include <vector>
 6#include <queue>
 7#include <set>
 8#include <map>
 9#include <string>
10#include <cmath>
11#include <cstdlib>
12#include <ctime>
13#define fst first
14#define sec second
15#define lson l,m,rt<<1
16#define rson m+1,r,rt<<1|1
17#define ms(a,x) memset(a,x,sizeof(a))
18typedef long long LL;
19#define pi pair < int ,int >
20#define MP make_pair
21using namespace std;
22const double eps = 1E-8;
23const int dx4[4]={1,0,0,-1};
24const int dy4[4]={0,-1,1,0};
25const int inf = 0x3f3f3f3f;
26LL C[30][30];
27LL dp[30][2];
28LL sum[25];
29void cal()
30{
31    for ( int i = 1 ; i <= 20 ; i++)
32    {
33        C[i][0] = 1;
34        C[i][i] = 1;
35    }
36    for ( int i = 2; i <= 20 ; i++)
37        for ( int j = 1 ; j < i ; j++)
38            C[i][j] = C[i-1][j] + C[i-1][j-1];
39}
40int main()
41{
42    cal();
43 /*   for ( int i = 2 ;i  <= 10 ; i++)
44    {
45        for ( int j = 0 ; j <= i ; j++)
46            printf("%d ",C[i][j]);
47        printf("\n");
48    } */
49    ms(sum,0);
50    sum[1] = 1;
51    dp[0][0]=dp[0][1]=dp[1][0]=dp[1][1] = 1;
52    for ( int i = 2 ; i <= 20 ; i++)
53    {
54        for ( int j = 0 ; j < i ; j++) //枚举第i个位置前有几个。
55        {
56            sum[i] += dp[j][0]*dp[i-1-j][1]*C[i-1][j];
57        }
58        dp[i][0] = dp[i][1] = sum[i]/2;
59    }
60//    for ( int i = 1; i <= 20 ; i++) printf("%lld\n",sum[i]);
61     int T;
62     cin>>T;
63     while (T--)
64     {
65         int cas,n;
66         scanf("%d%d",&cas,&n);
67         printf("%d %lld\n",cas,sum[n]);
68     }
69
70
71	return 0;
72}

Related

【dp专题001】bzoj 1009: [HNOI2008]GT考试 (字符串上dp+kmp+矩阵加速线性递推式)

·1111 words·3 mins
1009: [HNOI2008]GT考试 # Time Limit: 1 Sec Memory Limit: 162 MB Submit: 3127 Solved: 1926 [Submit][Status][Discuss] Description # 阿申准备报名参加GT考试,准考证号为N位数X1X2….Xn(0<=Xi<=9),他不希望准考证号上出现不吉利的数字。 他的不吉利数学A1A2…Am(0<=Ai<=9)有M位,不出现是指X1X2…Xn中没有恰好一段等于A1A2…Am. A1和X1可以为 0

codeforces 605 A. Sorting Railway Cars (dp)

·419 words·1 min
题目链接 题意:给出一个n个数的排列,每次可以把一个数放到最前面或者最后面的位置,问至少要进行多少次操作才能使得数列升序。 思路:考虑不被移动的那些数,当把所有一定的数去掉以后,这些剩下的数一定是一段数值连续,位置递增的数。如果想要移动的数最少,俺么这串递增的数就尽可能长。

hdu 5904 LCIS (dp)

·340 words·1 min
题目链接 题意: 给定两个序列,求它们的最长公共递增子序列的长度, 并且这个子序列的值是连续的 思路:以值为连续做入手点。 很显然个鬼咯 dp[a[i]]表示以a[i]结尾的最大长度。 dp[a[i]] = dp[a[i-1]] + 1 对于b序列一样。

斜率优化学习笔记

·211 words·1 min
参考博客 这个东西英文好像叫做:convex hull trick Convex_hull_trick_wiki codeforces convex hull trick 简单说说我的理解:斜率优化是一种数形结合的思想。。。 对于一个dp的若干状态。。。有些状态是不会对答案有贡献的。。。这些我们就可以不考虑。。。